//weihnachtsgeschenk 2004_5
unit kampfsim_u;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ImgList;

type
  TVisMonster=record
     l1,l2,l3:TLabel;
     health,gewandtheit,schaden:TEdit;
     schutz:TCheckBox;
     del:TButton;
  end;
  TMonster=record
    health,gew,attschaden,getschaden:integer;
  end;
  TForm1 = class(TForm)
    Panel1: TPanel;
    monsterList: TGroupBox;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Edit6: TEdit;
    Label7: TLabel;
    Edit7: TEdit;
    Button2: TButton;
    CheckBox2: TCheckBox;
    Edit8: TEdit;
    Timer1: TTimer;
    Button1: TButton;
    Panel2: TPanel;
    Panel3: TPanel;
    PaintBox1: TPaintBox;
    ImageList1: TImageList;
    ListBox1: TListBox;
    CheckBox1: TCheckBox;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    attackNacheinander: TRadioButton;
    attackOneDefendAll: TRadioButton;
    procedure FormCreate(Sender: TObject);
    procedure delMonsterClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ListBox1MeasureItem(Control: TWinControl; Index: Integer;
      var Height: Integer);
    procedure FormShow(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure PaintBox1Click(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
    procedure AddMonster();
    function random2(fast:boolean):integer;
  end;

var
  Form1: TForm1;
  visMonster:array of TVisMonster;
  heights:array[0..10] of integer;
implementation

{$R *.DFM}

procedure TForm1.addMonster;
var ym,i:integer;
  procedure setPos(c:TControl;x,y:integer);
  begin
    c.parent:=monsterList;
    c.left:=x;
    c.top:=y+ym;
    c.tag:=i;
  end;
  function createLabel(x,y:integer;caption:string):TLabel;
  begin
    result:=TLabel.create(FORM1);
    setPos(result,x,y);
    result.caption:=caption;
  end;
  function createButton(x,y:integer;caption:string;onClick:TNotifyEvent):TButton;
  begin
    result:=TButton.create(FORM1);
    setPos(result,x,y);
    result.caption:=caption;
    result.onClick:=onClick;
    result.width:=25;
  end;
  function createEdit(x,y:integer;text:string):TEdit;
  begin
    result:=TEdit.create(FORM1);
    setPos(result,x,y);
    result.text:=text;
    result.width:=37;
  end;
  function createCheckBox(x,y:integer;caption:string):TCheckBox;
  begin
    result:=TCheckBox.create(FORM1);
    setPos(result,x,y);
    result.caption:=caption;
  end;
begin
  ym:=50+25*length(visMonster);
  setlength(visMonster,length(visMonster)+1);
  i:=high(visMonster);
  with visMonster[i] do begin
    l1:=createLabel(8,5,'Strke:');
    l2:=createLabel(85,5,'Gewandheit:');
    l3:=createLabel(189,5,'Extraschaden:');
    health:=createEdit(45,0,'');
    gewandtheit:=createEdit(148,0,'');
    schaden:=createEdit(261,0,'0');
    schutz:=createCheckBox(304,2,'1 Treffer statt 2');
    del:=createButton(402,-2,'weg',delMonsterClick);
    del.enabled:=i<>0;
  end;
end;
procedure TForm1.FormCreate(Sender: TObject);
begin
  randomize;
  setlength(visMonster,0);
  AddMonster();
end;

procedure TForm1.delMonsterClick(Sender: TObject);
begin
  timer1.tag:=(sender as tcomponent).tag;
  timer1.enabled:=true;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  AddMonster;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var i,a:integer;
procedure delC(c:TControl);
begin
  c.Tag:=i;
  c.top:=c.top-25*a;
end;
procedure delX(c:TComponent);
begin
  c.free;
end;
begin
  timer1.enabled:=false;
  i:=(sender as tcomponent).tag;
  with visMonster[i] do begin
    delX(l1);
    delX(l2);
    delX(l3);
    delX(health);
    delX(gewandtheit);
    delX(schaden);
    delX(schutz);
    delX(del);
  end;
  visMonster[i]:=visMonster[high(visMonster)];
  setlength(visMonster,high(visMonster));
  if i=length(visMonster) then exit;
  a:=length(visMonster)-i;
  with visMonster[i] do begin
    delC(l1);
    delC(l2);
    delC(l3);
    delC(health);
    delC(gewandtheit);
    delC(schaden);
    delC(schutz);
    delC(del);
  end;

end;
function Tform1.random2(fast:boolean):integer;
var i,x1,x2,r1,r2:integer;
begin
  if fast then result:=random(12)+1
  else begin
    x1:= (paintbox1.width-70) div 2;
    x2:=x1+37;
    for i:=1 to 20 do begin
      r1:=random(6);
      r2:=random(6);
      result:=r1+r2+2;
      ImageList1.Draw(PaintBox1.Canvas,x1,2,r1);
      ImageList1.Draw(PaintBox1.Canvas,x2,2,r2);
      sleep(70);
    end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var monster:array of tmonster;
    kkm,kkh:integer;//kawmpfkraft monster/held
    health,gew,luck,extraSchaden,extraVerletzunhg:integer;
    fast:boolean;
    i,minluck:integer;

  procedure attackFromMonster(const mon:TMonster);
  begin
    application.processmessages;
    kkm:=random2(fast)+monster[i].gew;
    ListBox1.Items.AddObject('Kampfkraft (Monster): '+inttostr(kkm),TObject(0));
    Application.ProcessMessages;
    kkh:=random2(fast)+gew;
    ListBox1.Items.AddObject('Kampfkraft (Du): '+inttostr(kkh),TObject(0));
    Application.ProcessMessages;
    if kkm>kkh then begin
      health:=health-monster[i].attschaden;
      if luck>=minluck then
        if Application.messageBox(pchar('Du wurdest verletzt. '#13#10+
                                        'Deine Strke: '+inttostr(health)+' | Strke des Monsters: '+inttostr(monster[i].health)+#13#10+
                                        'Willst du dein Glck versuchen, um einen Strkepunkt zu erhalten?'#13#10+
                                        '(Wahrscheinlichkeit fr Erfolg: '+inttostr((luck*100) div 12)+'%)'#13#10+
                                        'Warnung: Bei Mierfolg verlierst du einen Extrapunkt'),'Kampfsimulator',MB_YESNO)=IDYES then begin
          if random2(fast)<=luck then health:=health+1
          else health:=health-1;
          luck:=luck-1;
        end;
      ListBox1.Items.AddObject('Du wurdest verletzt. Neue Strke: '+inttostr(health),TObject(3));
    end else if kkm=kkh then
      ListBox1.Items.AddObject('Niemand wurde verletzt',TObject(6));
  end;

  procedure defendOnlyMonster();
  var j:integer;
  begin
    if (length(monster)>1) and (attackOneDefendAll.Checked) then begin
      for j:=0 to high(monster)-1 do begin
        ListBox1.Items.AddObject('Abwehr nchstes Monster: ',TObject(1));
        attackFromMonster(monster[j]);
        if kkh>kkm then
          ListBox1.Items.AddObject('Angriff des Monsters abgewehrt',TObject(2));
      end;
    end;
  end;
begin
  fast:=checkbox1.checked;
  setlength(monster,length(vismonster));
  for i:=0 to high(visMonster) do begin
    with monster[high(visMonster)-i] do begin
      health:=strtoint(vismonster[i].health.Text);
      gew:=strtoint(vismonster[i].gewandtheit.Text);
      attschaden:=strtoint(vismonster[i].schaden.Text)+2;
      if visMonster[i].schutz.Checked then getschaden:=1
      else getschaden:=2;
    end;
  end;
  health:=strtoint(edit4.text);
  gew:=strtoint(edit5.text);
  luck:=strtoint(edit8.text);
  minluck:=strtoint(edit1.text);
  if not checkbox2.checked then minluck:=1000;
  extraSchaden:=strtoint(edit6.text);
  extraVerletzunhg:=strtoint(edit7.text);
  ListBox1.Clear;
  for i:=high(monster)  downto 0 do begin
    ListBox1.Items.AddObject('',TObject(1));
    ListBox1.Items.AddObject('Nchstes Monster: ',TObject(1));
    ListBox1.Items.AddObject('Strke: '+inttostr(monster[i].health),TObject(0));
    ListBox1.Items.AddObject('Gewandheit: '+inttostr(monster[i].gew),TObject(0));
    while true do begin
      attackFromMonster(monster[i]);
      if kkh>kkm then begin
        monster[i].health:=monster[i].health-monster[i].getschaden-extraSchaden;
        if luck>=minluck then
          if Application.messageBox(pchar('Das Monster wurde verletzt. '#13#10+
                                          'Deine Strke: '+inttostr(health)+' | Strke des Monsters: '+inttostr(monster[i].health)+#13#10+
                                          'Willst du dein Glck versuchen, um das Monster um 2 Strkepunkte mehr zu verletzen?'#13#10+
                                          '(Wahrscheinlichkeit fr Erfolg: '+inttostr((luck*100) div 12)+'%)'#13#10+
                                          'Warnung: Bei Mierfolg bekommt es einen Extrapunkt'),'Kampfsimulator',MB_YESNO)=IDYES then begin
            if random2(fast)<=luck then monster[i].health:=monster[i].health-2
            else monster[i].health:=monster[i].health+1;
            luck:=luck-1;
          end;
        ListBox1.Items.AddObject('Das Monster wurde verletzt. Neue Strke: '+inttostr(monster[i].health),TObject(2));
      end;
      if monster[i].health<=0 then begin
        ListBox1.Items.AddObject('Das Monster ist tot',TObject(4));
        defendOnlyMonster();
        SetLength(monster,high(monster));
        break;
      end;
      if extraVerletzunhg<>0 then begin
        health:=health-extraVerletzunhg;
        ListBox1.Items.AddObject('Du wurdest verletzt (Rundenschaden). Neue Strke: '+inttostr(health),TObject(7));
      end;
      if health<=0  then begin
        ListBox1.Items.AddObject('Du bist tot',TObject(5));
        exit;
      end;
      defendOnlyMonster();
    end;
  end;
  ListBox1.Items.AddObject('Du gewinnst mit Strke: '+inttostr(health),TObject(8));
  if CheckBox2.Checked then
    ListBox1.Items.AddObject('Dein Glck betrgt: '+inttostr(luck),TObject(0));
end;

procedure TForm1.ListBox1MeasureItem(Control: TWinControl; Index: Integer;
  var Height: Integer);
begin
  height:=heights[integer(tlistbox(control).items.objects[index])];
end;

procedure TForm1.FormShow(Sender: TObject);
begin
{ 'Nchstes Monster: ' 1;
  Info: 0
  'Das Monster wurde verletzt. Neue Strke: '+inttostr(monster[i].health),TObject(2));
  'Du wurdest verletzt. Neue Strke: '+inttostr(health),TObject(3));
  'Das Monster ist tod',TObject(4));
  'Du bist tod',TObject(5));
  'Du wurdest verletzt (Rundenschaden). Neue Strke: '+inttostr(health),TObject(7));
  'Du gewinnst mit Strke: '+inttostr(health),TObject(8));}
  listbox1.canvas.Font.Style:=[];
  heights[0]:=listbox1.canvas.TextHeight('Abg,M');
  listbox1.canvas.Font.Style:=[fsBold];
  heights[1]:=listbox1.canvas.TextHeight('Abg,M');
  heights[2]:=heights[1];
  heights[3]:=heights[1];
  heights[4]:=heights[1];
  heights[5]:=heights[1];
  heights[6]:=heights[1];
  heights[7]:=heights[1];
  heights[8]:=heights[1];

end;

procedure TForm1.ListBox1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
begin
  with ListBox1.Canvas.font do
    case integer(listbox1.items.objects[index]) of
      0: begin
           color:=clBlack;
           Style:=[];
         end;
      1: begin
           color:=clBlack;
           Style:=[fsBold];
         end;
      2: begin
           color:=clGreen;
           Style:=[fsBold];
         end;
      3: begin
           color:=clRed;
           Style:=[fsBold];
         end;
      4: begin
           color:=clGreen;
           Style:=[fsBold];
         end;
      5: begin
           color:=clRed;
           Style:=[fsBold];
         end;
      6: begin
           color:=clBlack;
           Style:=[fsBold];
         end;
      7: begin
           color:=clRed;
           Style:=[fsBold];
         end;
      8: begin
           color:=clGreen;
           Style:=[fsBold];
         end;
    end;
  ListBox1.Canvas.TextRect(rect,rect.left+4,rect.top,listbox1.items[index] );
end;

procedure TForm1.PaintBox1Click(Sender: TObject);
begin
  random2(false);
end;

end.

